package com.yoai.react.social;

import android.app.Activity;
import android.content.Intent;

import com.facebook.react.ReactPackage;
import com.facebook.react.bridge.JavaScriptModule;
import com.facebook.react.bridge.NativeModule;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.uimanager.ViewManager;

import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

public class ReactNativeSocialPackage implements ReactPackage {

  private final Activity activity;

  private SocialModule socialModule;

  public ReactNativeSocialPackage(Activity activity) {
    this.activity = activity;
  }

  @Override
  public List<NativeModule> createNativeModules(ReactApplicationContext reactContext) {
    this.socialModule = new SocialModule(reactContext, this.activity);

    List<NativeModule> nativeModules = new LinkedList<>();
    nativeModules.add(this.socialModule);
    return nativeModules;
  }

  @Override
  public List<Class<? extends JavaScriptModule>> createJSModules() {
    return Collections.emptyList();
  }

  @Override
  public List<ViewManager> createViewManagers(ReactApplicationContext reactContext) {
    return Collections.emptyList();
  }

  public void onActivityResult(int requestCode, int resultCode, Intent data) {
    this.socialModule.onActivityResult(requestCode, resultCode, data);
  }
}
