package com.yoai.react.social;

import android.app.Activity;
import android.app.Application;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;

import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.ReadableMap;


public class SocialModule extends ReactContextBaseJavaModule {
  private static final String TAG = "SocialModule";

  private static final String CHANNEL_WEIBO = "weibo";
  private static final String CHANNEL_WEIXIN = "weixin";

  private final WeiboPlugin weiboPlugin;

  public SocialModule(ReactApplicationContext reactContext, Activity activity) {
    super(reactContext);
    this.weiboPlugin = new WeiboPlugin(activity);
  }

  /**
   * @return the name of this module. This will be the name used to {@code require()} this module
   * from javascript.
   */
  @Override
  public String getName() {
    return "SocialModule";
  }

  @ReactMethod
  public void authorize(final String channel, final ReadableMap config, final Callback callback) {
    if (CHANNEL_WEIBO.equals(channel)) {
      weiboPlugin.authorize(config, callback);
    } else {
      Log.e(TAG, "authorize...unknown channel " + channel);
    }
  }

  public void onActivityResult(int requestCode, int resultCode, Intent data) {
    weiboPlugin.onActivityResult(requestCode, resultCode, data);
  }
}
